public class Point {
        // instance member field
        protected int x, y;

        // static member field
        public static int count = 0;

        // constructor & destructor
        public Point() {
        	this(0, 0);
        }
        
        public Point(int x, int y) { 
        	this.x = x; 
        	this.y = y; 
        	count++; 
        }

        // method
        public void print() { // virtual method
        	System.out.printf("X=%d Y=%d\n", x, y); 
        }         

	@Override
        public String toString() { // toString method override 
        	return "(" + x + " , " + y + ")";
        }  

        public void setPosition(int x, int y) { 
        	this.x = x; 
        	this.y = y; 
        }

        public void move(int x, int y) { 
        	this.x += x; 
        	this.y += y; 
        }
       
        public static int getCount() { // static method
        	return count; 
        }

	// Java does not support Operator Overloading ++, ++, ==, etc
        
        public void setX(int x) { 
        	this.x = x; 
        }
        
        public void setY(int y) { 
        	this.y = y; 
        }

        public int getX() { 
        	return x; 
        }
        
        public int getY() { 
        	return y; 
        }

	@Override
        public boolean equals(Object obj)
        {
            if (!(obj instanceof Point))
                return false;
            return equals((Point)obj);
        }

        public boolean equals(Point other)
        {
            if (this.x == other.x && this.y == other.y)
                return true;
            return false;
        }
}
