public class Point3D extends Point {
        // instance member field
        protected int z;

        // constructor & destructor
        public Point3D() {
		this(0, 0, 0);
	}

        public Point3D(int x, int y, int z) {
		super(x, y);
		this.z = z;
	}

        public void setPosition(int x, int y, int z) { 
		super.setPosition(x, y); 
		this.z = z; 
	}

        public void move(int x, int y, int z) { 
		super.move(x, y); 
		this.z += z; 
	}

	@Override
        public void print() { // overrided method
		System.out.printf("X=%d Y=%d Z=%d\n", x, y, z); 
	}

	@Override   
        public String toString() { // override toString method
		return "(" + x + " , " + y + " , " + z + ")"; 
	} 

        public void setZ(int z) { 
		this.z = z; 
	}

        public int getZ() { 
		return z; 
	}

	@Override
        public boolean equals(Object obj)
        {
            if (!(obj instanceof Point3D))
                return false;
            return equals((Point3D)obj);
        }

        public boolean equals(Point3D other)
        {
            if (this.x == other.x && this.y == other.y && this.z == other.z)
                return true;
            return false;
        }
}
